package services.ejb;

import java.util.List;

import services.entities.Customer;
import services.entities.PricingMethod;
import services.exceptions.CreateDataException;

public interface CustomerManager {
	
	public Customer findByPrimaryKey(long customerId);
   
    public int numberOfCustomers();
   
    public List<Customer> findAllCustomers();
   
    public void createCustomer(Customer customer);
   
    public void createPricingMethod(PricingMethod pricingMethod);
    
    public void createCustomers(int numberOfCustomers, int batchSize) throws CreateDataException;

}
