package services.ejb;

import java.math.BigDecimal;
import java.util.List;

import services.entities.Product;
import services.exceptions.CreateDataException;
import services.exceptions.PricingMethodNotFoundException;
import services.exceptions.ProductNotFoundException;

public interface ProductManager {

	public int numberOfProducts();

	public List<Product> findAllProducts();

	public void createProduct(Product product);

	public void createProducts(int numberOfProducts, int batchSize) throws CreateDataException;

	public BigDecimal price(long customerId
			, long productId) throws PricingMethodNotFoundException, ProductNotFoundException;

	public BigDecimal extendedPrice(BigDecimal price
			, long quantity);

	public long whatIsTheDemand(long productId
			, long distributionCenterId);

}
