package services.entities;

import java.io.Serializable;

import javax.persistence.Embeddable;

@Embeddable()
public class Address implements Serializable {

	private static final long serialVersionUID = -353173496086685568L;
	private String addressLine1;
	private String addressLine2;
	private String city;
	private String state;
	private int zipCode;
	private int zipCodePlusFour;

	public Address() {

	}

	public String getAddressLine1() {

		return addressLine1;

	}

	public void setAddressLine1(String addressLine1) {

		this.addressLine1 = addressLine1;

	}

	public String getAddressLine2() {

		return addressLine2;

	}

	public void setAddressLine2(String addressLine2) {

		this.addressLine2 = addressLine2;

	}

	public String getCity() {

		return city;

	}

	public void setCity(String city) {

		this.city = city;

	}

	public String getState() {

		return state;

	}

	public void setState(String state) {

		this.state = state;

	}

	public int getZipCode() {

		return zipCode;

	}

	public void setZipCode(int zipCode) {

		this.zipCode = zipCode;

	}

	public int getZipCodePlusFour() {

		return zipCodePlusFour;

	}

	public void setZipCodePlusFour(int zipCodePlusFour) {

		this.zipCodePlusFour = zipCodePlusFour;

	}

	public boolean equals(Object o) {

		if (this == o) {
			return true;
		}

		if (o == null || getClass() != o.getClass()) {
			return false;
		}

		final Address address = (Address) o;

		if (!addressLine1.equals(address.addressLine1)) {
			return false;
		}

		if (!addressLine2.equals(address.addressLine2)) {
			return false;
		}

		if (!city.equals(address.city)) {
			return false;
		}

		if (!state.equals(address.state)) {
			return false;
		}

		if (!(zipCode == address.zipCode)) {
			return false;
		}

		if (!(zipCodePlusFour == address.zipCodePlusFour)) {
			return false;
		}

		return true;

	}

	public int hashCode() {

		int hashValue;

		if (addressLine2 != null) {
			hashValue = addressLine1.hashCode()
				+ addressLine2.hashCode()
				+ city.hashCode()
				+ state.hashCode()
				+ zipCode
				+ zipCodePlusFour;
		} else {
			hashValue = addressLine1.hashCode()
				+ city.hashCode()
				+ state.hashCode()
				+ zipCode
				+ zipCodePlusFour;
		}

		return hashValue;

	}

}
