package services.entities;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Cache(usage = CacheConcurrencyStrategy.NONE)
@Entity
public class OrderLine implements Serializable {

	private static final long serialVersionUID = -7921374356903635324L;
	private OrderLinePK orderLinePK;
	private long productId;
	private long quantity;
	private BigDecimal price;
	private BigDecimal extendedPrice;
	private Order order;

	public OrderLine() {

		orderLinePK = new OrderLinePK();

	}

	@EmbeddedId
	public OrderLinePK getOrderLinePK() {

		return orderLinePK;

	}


	public void setOrderLinePK(OrderLinePK orderLinkPK) {

		this.orderLinePK = orderLinkPK;

	}

	public long getProductId() {

		return productId;

	}

	public void setProductId(long productId) {

		this.productId = productId;

	}

	public long getQuantity() {

		return quantity;

	}

	public void setQuantity(long quantity) {

		this.quantity = quantity;

	}

	public BigDecimal getPrice() {

		return price;

	}

	public void setPrice(BigDecimal price) {

		this.price = price;

	}

	public BigDecimal getExtendedPrice() {

		return extendedPrice;

	}

	public void setExtendedPrice(BigDecimal extendedPrice) {

		this.extendedPrice = extendedPrice;

	}

	@ManyToOne()
	@JoinColumn(name="OrderId", insertable=false, updatable=false)
	public Order getOrder() {

		return order;

	}

	public void setOrder(Order order) {

		this.order = order;

	}

	public boolean equals(Object o) {

		if (this == o) {
			return true;
		}

		if (o == null || getClass() != o.getClass()) {
			return false;
		}

		final OrderLine orderLine = (OrderLine) o;

		if (!orderLinePK.equals(orderLine.orderLinePK)) {
			return false;
		}

		if (!(productId == orderLine.productId)) {
			return false;
		}

		if (!(quantity == orderLine.quantity)) {
			return false;
		}

		if (!price.equals(orderLine.price)) {
			return false;
		}

		if (!extendedPrice.equals(orderLine.extendedPrice)) {
			return false;
		}

		if (!order.equals(orderLine.order)) {
			return false;
		}

		return true;

	}

	public int hashCode() {

		int hashValue;

		hashValue = orderLinePK.hashCode()
		+ Long.toString(productId).hashCode()
		+ Long.toString(quantity).hashCode()
		+ price.hashCode()
		+ extendedPrice.hashCode();

		return hashValue;

	}

}
