package services.entities;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Transient;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
@Entity
public class PricingMethod implements Serializable {

	private static final long serialVersionUID = -4989578629120920523L;
	private long customerId;
	private boolean costPlus;
	private boolean listLess;
	private BigDecimal percent;
	private Customer customer;

	public PricingMethod() {

	}

	@Id
	public long getCustomerId() {

		return customerId;

	}

	public void setCustomerId(long customerId) {

		this.customerId = customerId;

	}

	public boolean getCostPlus() {

		return costPlus;

	}

	public void setCostPlus(boolean costPlus) {

		this.costPlus = costPlus;

	}

	public boolean getListLess() {

		return listLess;

	}

	public void setListLess(boolean listLess) {

		this.listLess = listLess;

	}

	public BigDecimal getPercent() {

		return percent;

	}

	public void setPercent(BigDecimal percent) {

		this.percent = percent;

	}

	@Transient
	public boolean isCostPlus() {

		return costPlus;

	}

	@Transient
	public boolean isListLess() {

		return listLess;

	}

	@OneToOne(cascade={})
	@JoinColumn(name="CustomerId", insertable=false, updatable=false)
	public Customer getCustomer() {

		return customer;

	}

	public void setCustomer(Customer customer) {

		this.customer = customer;

	}

	public boolean equals(Object o) {

		if (this == o) {
			return true;
		}

		if (o == null || getClass() != o.getClass()) {
			return false;
		}

		final PricingMethod pricingMethod = (PricingMethod) o;

		if (!(customerId == pricingMethod.customerId)) {
			return false;
		}

		if (!(costPlus == pricingMethod.costPlus)) {
			return false;
		}

		if (!(listLess == pricingMethod.listLess)) {
			return false;
		}

		if (!percent.equals(pricingMethod.percent)) {
			return false;
		}

		return true;

	}

	public int hashCode() {

		int hashValue;

		hashValue = Long.toString(customerId).hashCode()
		+ Boolean.toString(costPlus).hashCode()
		+ Boolean.toString(listLess).hashCode()
		+ percent.hashCode();

		return hashValue;

	}

}
