package services.entities;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
@Entity
@NamedQueries(value={ @NamedQuery(name="selectAllTheProducts", query="from Product order by productId")
		, @NamedQuery(name="selectProductById", query="from Product where ProductId = :productId")
		})
public class Product implements Serializable {

	private static final long serialVersionUID = -7218878900053840523L;
	
	private long productId;
	private String description;
	private BigDecimal cost;
	private BigDecimal listPrice;

	public Product() {

	}

	@Id
	public long getProductId() {

		return productId;

	}

	public void setProductId(long productId) {

		this.productId = productId;

	}

	public String getDescription() {

		return description;

	}

	public void setDescription(String description) {

		this.description = description;

	}

	public BigDecimal getCost() {

		return cost;

	}

	public void setCost(BigDecimal cost) {

		this.cost = cost;

	}

	public BigDecimal getListPrice() {

		return listPrice;

	}

	public void setListPrice(BigDecimal listPrice) {

		this.listPrice = listPrice;

	}

	public boolean equals(Object o) {

		if (this == o) {
			return true;
		}

		if (o == null || getClass() != o.getClass()) {
			return false;
		}

		final Product product = (Product) o;

		if (!(productId == product.productId)) {
			return false;
		}

		if (!description.equals(product.description)) {
			return false;
		}

		if (!cost.equals(product.cost)) {
			return false;
		}

		if (!listPrice.equals(product.listPrice)) {
			return false;
		}

		return true;

	}

	public int hashCode() {

		int hashValue;

		hashValue = Long.toString(productId).hashCode()
		+ description.hashCode()
		+ cost.hashCode()
		+ listPrice.hashCode();

		return hashValue;

	}

}
