/*
 * JBoss, the OpenSource J2EE webOS
 * 
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package services.entities;

import java.io.Serializable;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
@Entity
public class Region implements Serializable {

   /** The serialVersionUID */
   private static final long serialVersionUID = -4811801934695990404L;
   private RegionPK regionPK;
   private int zipCodePlusFour;
   private String city;
   private String state;
   private DistributionCenter distributionCenter;
   
   public Region() {

   }
   
   @EmbeddedId
   public RegionPK getPrimaryKey() {
      
      return regionPK;
      
   }
   
   public void setPrimaryKey(RegionPK regionPK) {
      
      this.regionPK = regionPK;
      
   }
   
   public int getZipCodePlusFour() {
      
      return zipCodePlusFour;
      
   }
   
   public void setZipCodePlusFour(int zipCodePlusFour) {
      
      this.zipCodePlusFour = zipCodePlusFour;
      
   }
   
   public String getCity() {
      
      return city;
      
   }
   
   public void setCity(String city) {
      
      this.city = city;
      
   }
   
   public String getState() {
      
      return state;
      
   }
   
   public void setState(String state) {
      
      this.state = state;
      
   }
   
   @ManyToOne()
   @JoinColumn(name="DistributionCenterId", insertable=false, updatable=false)
   public DistributionCenter getDistributionCenter() {
      
      return distributionCenter;
      
   }
   
   public void setDistributionCenter(DistributionCenter distributionCenter) {
      
      this.distributionCenter = distributionCenter;
      
   }
   
   public boolean equals(Object o) {
      
      if (this == o) {
         return true;
      }
      
      if (this == null || getClass() != o.getClass()) {
         return false;
      }
      
      final Region region = (Region) o;
      
      if (!(regionPK.equals(region.getPrimaryKey()))) {
         return false;
      }
      
      if (!(zipCodePlusFour == region.zipCodePlusFour)) {
         return false;
      }
      
      if (!(city.equals(region.city))) {
         return false;
      }
      
      if (!(state.equals(region.state))) {
         return false;
      }
      
      return true;
      
   }
   
   public int hashCode() {
      
      int hashValue;
      
      hashValue = regionPK.hashCode()
         + Long.toString(zipCodePlusFour).hashCode()
         + city.hashCode()
         + state.hashCode();
      
      return hashValue;
      
   }

}
