/*
 * JBoss, the OpenSource J2EE webOS
 * 
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package services.entities;

import java.io.Serializable;

import javax.persistence.Embeddable;

@Embeddable
public class RegionPK implements Serializable {

   /** The serialVersionUID */
   private static final long serialVersionUID = 8829793128652823140L;
   private long distributionCenterId;
   private int zipCode;
   
   public RegionPK() {

   }
   
   public long getDistributionCenterId() {
      
      return distributionCenterId;
      
   }
   
   public void setDistributionCenterId(long distributionCenterId) {
      
      this.distributionCenterId = distributionCenterId;
      
   }
   
   public int getZipCode() {
      
      return zipCode;
      
   }
   
   public void setZipCode(int zipCode) {
      
      this.zipCode = zipCode;
      
   }
   
   public boolean equals(Object o) {
      
      if (this == o) {
         return true;
      }
      
      if (o == null || getClass() != o.getClass()) {
         return false;
      }
      
      final RegionPK regionPK = (RegionPK) o;
      
      if (!(distributionCenterId == regionPK.distributionCenterId)) {
         return false;
      }
      
      if (!(zipCode == regionPK.zipCode)) {
         return false;
      }
      
      return true;
      
   }
   
   public int hashCode() {
      
      int hashValue;
      
      hashValue = Long.toString(distributionCenterId).hashCode()
         + Integer.toString(zipCode).hashCode();
      
      return hashValue;
      
   }

}
